public class Rubberband extends GGen {
    GGen rubber;
    GGen leftObj;
    GGen rightObj;

    -0.1 => float POS_Z;
    1. => float BASE_HEIGHT;
    2. => float MAX_HEIGHT;
    
    // Audio Listener =============================================================
    AudioListener audioListener;
    fun void setAudioListener(AudioListener audioListener_) {
        audioListener_ @=> audioListener;
    }
    fun float heightModifier() {
        return BASE_HEIGHT + Math.clampf(2. * audioListener.getScaledVolume(), 0., MAX_HEIGHT - BASE_HEIGHT);
    }

    // Physics and visuals ========================================================

    // Assumption: endpoints of rubber_ are (0,0,0) and (1, 0, 0)
    // Assumption: rubber_ "faces" camera
    fun void setRubber(GGen rubber_) {
        rubber_ @=> rubber;
        rubber --> this;
    }

    fun void setEndpointObjects(GGen left, GGen right) {
        left @=> leftObj;
        right @=> rightObj;
    }

    fun void update(float dt) {
        setEndpoints(leftObj.pos(), rightObj.pos(), heightModifier());
    }

    // Internal helper functions ==================================================

    // Assumption: left.z = right.z = 0
    fun void setEndpoints(vec3 left, vec3 right, float heightModifier) {
        left => rubber.pos;

        getPolar(right - left) => polar diff;
        rubber.sca(@(Math.mag(diff), heightModifier, 1));
        rubber.rotZ(Math.phase(diff));

        // set rubberband behind objects
        rubber.posZ(POS_Z);
    }


    // Math helper functions ======================================================
    fun polar getPolar(vec3 vec) {
        return (vec.x + vec.y * Math.I) $ polar;
    }
}