global float screenAspect, screenHeight, screenWidth;

// update pad positions on window resize
fun void resizeListener() {
    updateAspectVars();
    WindowResizeEvent e;  // now listens to the window resize event
    while (true) {
        e => now;  // window has been resized!
        <<< GG.windowWidth(), " , ", GG.windowHeight() >>>;
        updateAspectVars();
    }
} 
spork ~ resizeListener();

// place pads based on window size
fun void updateAspectVars() {
    // recalculate aspect
    (GG.frameWidth() * 1.0) / (GG.frameHeight() * 1.0) => screenAspect;
    // calculate ratio between old and new height/width
    GG.camera().viewSize() => screenHeight;  // height of screen in world-space units
    screenHeight * screenAspect => screenWidth;  // widht of the screen in world-space units
}